
import hpjava.* ;


class Producer1 extends Thread {
  Port peer, out ;

  public Producer1 (Port peer, Port out) {
    this.peer = peer ;
    this.out  = out ;
  }

  public void run() {
    //while(true) {
    for(int i = 0 ; i < 100 ; i++) {
      out.sendInt(1) ;
      peer.sendChan(out) ;
      peer.recvChan(out) ;
    }
  }
}

class Producer2 extends Thread {
  Port peer ;

  public Producer2 (Port peer) {
    this.peer = peer ;
  }

  public void run() {
    Port out = new Port() ;
    //while(true) {
    for(int i = 0 ; i < 100 ; i++) {
      peer.recvChan(out) ;
      out.sendInt(2) ;
      peer.sendChan(out) ;
    }
  }
}

class Consumer extends Thread {
  Port in ;

  public Consumer (Port in) {
    this.in = in ;
  }

  public void run() {
    //while(true)
    for(int i = 0 ; i < 200 ; i++)
      System.out.println(in.recvInt()) ;
  }
}

public class Eg3 {
  public static void main(String args[]) {
    Port P = new Port() ;
    Port Q = new Port() ;

    Port.channel(P, Q) ;

    Port R = new Port() ;
    Port S = new Port() ;

    Port.channel(R, S) ;

    (new Producer1(P, R)).start() ;
    (new Producer2(Q)).start() ;
    (new Consumer(S)).start() ;
  }
}


